#include<reg52.h>
sbit rw =P3^0;   //Read/Write Pin
sbit en1=P3^1;   //Enable for First 80 Characters
sbit rs =P3^2;   //Register select (RS)
sbit en2=P3^3;   //Enable for Second 80 Characters
	

void delay(unsigned int time)  //Time delay function
{
unsigned int i,j;
for(i=0;i<time;i++)
for(j=0;j<5;j++);
}

             //Function for sending values to the command register of LCD
void lcdcmd1(unsigned char value)  
{
P1=value;
rs = 0;
rw = 0;
en1 = 1;             		
delay(50);
en1=0;
delay(50);

}
             //Function for sending values to the command register of LCD
void lcdcmd2(unsigned char value)  
{
P1=value;
rs = 0;
rw = 0;
en2 = 1;             		
delay(50);
en2=0;
delay(50);

}
             //Function for sending values to the data register of LCD
void display1(unsigned char value)  
{
P1=value;
rs = 1;
rw = 0;
en1 = 1;           		
delay(500);
en1=0;
delay(50);

}
             //Function for sending values to the data register of LCD
void display2(unsigned char value)  
{
P1=value;
rs = 1;
rw = 0;
en2 = 1;           		
delay(500);
en2=0;
delay(50);

}
             //function to initialize the registers and pins of LCD
             //always use with every lcd of hitachi
void lcdint1(void)         
{
P1=0x00;                 
P3=0x00;
delay(15000);
display1(0x30);
delay(4500);
display1(0x30);
delay(300);
display1(0x30);
delay(650);
lcdcmd1(0x38);
delay(50);
lcdcmd1(0x0F);
delay(50);
lcdcmd1(0x01);
delay(50);
lcdcmd1(0x06);
delay(50);
}

void lcdint2(void)         
{
P1=0x00;                 
P3=0x00;
delay(15000);
display2(0x30);
delay(4500);
display2(0x30);
delay(300);
display2(0x30);
delay(650);
lcdcmd2(0x38);
delay(50);
lcdcmd2(0x0F);
delay(50);
lcdcmd2(0x01);
delay(50);
lcdcmd2(0x06);
delay(50);
}

void main()
{

unsigned int count=0;
char st[]="Its 40x4 Lcd microcontroller-project.com";
P1=0x00; //Port-1 as Output
P3=0x00; //Port-2 as Output
lcdint1();
lcdint2();


while(1){
lcdcmd1(0x80);
		while(count!=40){
			display1(st[count]);
			 count++;
			}
count=0;
delay(5);
lcdcmd1(0xC0);
		while(count!=40){
			display1(st[count]);
			 count++;
			}
count=0;
delay(5);
lcdcmd2(0x80);
		while(count!=40){
			display2(st[count]);
			 count++;
			}
count=0;
delay(5);
lcdcmd2(0xC0);
		while(count!=40){
			display2(st[count]);
			 count++;
			}
count=0;
}			 
}